package state51::Job::EnsureFileReplicated;
use MooseX::Types::Moose qw/ Int /;
use Moose;
use Moose::Util::TypeConstraints;
extends 'state51::Job';

has 'file_id' => (
    is            => 'ro',
    isa           => Int,
    documentation => "The state51::File ID that we are acting on",
);

sub exchange_name { 'ensurefilereplicated' }

sub run {
    my ($self) = @_;
    state51::Base->connect;

    my ($file) = state51::File->load_oids( $self->file_id );

    #am i a master?
    if ( !$file->encoded_by_us ) {
        if ( $file->ensure_replicated ) {
            $file->update();
            $self->logger->message(
                level   => 'info',
                message => [
                    state51::Logger::Event::Generic->new(
                        message =>
                          sprintf( 'Replicating %s into Ceph', $file->id )
                    )
                ]
            );
        }
    }
}

__PACKAGE__->meta->make_immutable;
1;
