```plantuml
@startuml img/automated_export_workflow.png
title Automated Export Workflow

(*) --> "post order" as post_order
if "require_xls_validation?" then
  -left-> [yes] "Job::CreateDeliverDesiresForXls" as create_deliverdesires_for_xls
  --> validate_deliver_desires
else
  [no] if "require_deliver_desires_validation \n|| require_service_metadata_xls_validation ?" then
      -left-> [yes] "Job::ValidateDeliverDesires" as validate_deliver_desires
      --> "set order status to 'ready'"
      -->request_transforms_for_order
  else
    [no] if "require_file_transforms" then
      -left-> [yes] "Job::RequestTransformsForOrder" as request_transforms_for_order
    else
      [no] if "is_waiting_for_deliver_desires" then
        -left-> [yes] "Job::CreateDeliverDesiresForWholeCatalogue" as create_deliver_desires_for_whole_catalogue
        -->request_transforms_for_order
      endif
    endif
  endif
endif

request_transforms_for_order -left->[hourly for 'ready' orders] "Job::CheckAnOrderIsReadyForDelivery" as check_an_order_is_ready_for_delivery
--> "set 'last_all_formats_exportable_check'"
--> ===B1===
  -left-> "Check if products are exportable"
  --> ===B3===
  -right-> ===B2===
  --> if "are all products exportable?" then
    -->[yes] "set 'all_formats_exportable'"
    --> "Job::KickOffDeliveriesForOrder" as kickoff_deliveries
    --> "Check 'transforms_requested','all_transforms_completed',\n'service_metadata_processed','all_formats_exportable' all are set"
    --> if "are flags OK?" then
      -->[yes] "set 'automatic_delivery_job_started'"
      -->if "can DeliveryPoint export_automatically?" then
        -->[yes] "Job::DeliverOneDPForOrder" as deliver_one_dp
        note right: a Job is triggered per DeliveryPoint
        --> "check products not exported yet" as pending_deliver
        --> "export and transfer products"
        --> if "export and transfer finished successfully" then
          -->[yes] "check whole order delivery_status"
          --> if "Are all deliveries to all MS complete?" then
            -->[yes] "Flag order as complete and resolve ticket" as complete_order
            -left-> (*)
          else
            -right->[no] "Continue with remaining deliveries"
            -up-> pending_deliver
          endif
        else
          -left->[no] "Comment errors on Ticket and open it"
        endif
      else
        -left->[no] "Comment on RT and open Ticket"
      endif

    else
      -left->[no] "Wait for preconditions be meet\nor error report from Guardian Scripts"
      note left
        There are Guardian Scripts which checks orders
        orders looking for issues like:
        - not request transforms asked
        - due date so close and delivery not started
        - service metadata xls not processed
        - delivery desires not generated
        - not automatic check done
      end note
    endif
  else
    -->[no] "set 'order_failed_to_be_deliverable'"
    --> "Open RT Ticket"
  endif

===B1=== --> if "are requested encodes\ncomplete?" then
  -->[yes] "set 'all_transforms_completed'"
  --> ===B2===
else
  -right->[no] "Comment on ticket\nNumber of encodes in\n'failed' or 'problem' status"
  --> ===B2===
endif

===B3=== -left-> "Take exportable deliver desires and \ntrigger state51::Job::DeliverOneDPForOrder::DesireList"
    note top
      Check if this works as expected.
      How to ensure this is not lost?
    end note


"Ticket is open" -up-> "Needs manual intervention" as manual_intervention
-up-> complete_order

@enduml
```
