package state51::Job::FixBrokenFile::Action::File::Junk;
use state51::Moose;
use state51::DeliverDesire;

extends qw/ state51::Job::FixBrokenFile::Action::File /;

sub is_terminal { 1; }

sub full_message {
    my ($self) = @_;
    return $self->message."\n\nFile ".$self->file->id." is being marked as unfixable, it cannot complete.\n";
}

sub action {
    my ($self) = @_;

    foreach my $x (grep { $_->status ne "complete" && $_->status ne "unfixable" } $self->file->master_of->flatten) {
        $x->status('unfixable');
        $x->update();

        if ($x->to_fulfil && $x->target_track) {
            foreach my $dd (state51::DeliverDesire->fetch( asset => $x->target_track->releaseformat, request => $x->to_fulfil, status => 'needs_tx')) {
                warn "marking delivery desire as undeliverable: ".$dd->id;
                $dd->set_undeliverable("tx_unfixable");
            }
        }
    }

    return;
}

__PACKAGE__->meta->make_immutable;
1;

