package state51::Job::FixBrokenFile::Action::File::Rederive;
use state51::Moose;
use state51::TransformStep;

extends qw/ state51::Job::FixBrokenFile::Action::File /;

sub is_terminal { 0; }
sub full_message {
    my ($self) = @_;
    return $self->message."\n\nAction taken: Deleting ".$self->file->id." and re-requesting following transforms.";
}

sub action {
    my ($self) = @_;

    state51::Base->storage->tx_do(sub {

    $self->file->erase_only_me();

    foreach my $x (grep { $_->status ne "junk" } $self->file->my_filetransforms->flatten) {
        $x->status('junk');
        $x->update();

        my $replaced_by = state51::TransformStep::post_transforms_for_steps(
                [$x->encode->to],
                [$x->target_track->master_audio],
                $x->target_track,
                $x->target_transform,
        );
        foreach my $r (@{ $replaced_by }) {
            $x->to_fulfil->register_transform($r) if $x->to_fulfil();
            $r->upsert();
        }
    }

    });

    return;
}

__PACKAGE__->meta->make_immutable;
1;

