package state51::Job::FixBrokenFile::Action::FileTransform::Leave;
use Moose;
extends qw/ state51::Job::FixBrokenFile::Action::FileTransform /;

sub is_terminal { 1; }

sub full_message {
    my ($self) = @_;

    if ($self->filetransform->to_fulfil && $self->filetransform->to_fulfil->status ne 'ready') {
        return $self->message."\n\nMarking as unfixable problem transform ".$self->filetransform->id.", as order is no longer active.\n";
    }
    else {
        return $self->message."\n\nNo action taken to ".$self->filetransform->id.", leaving for now.\n";
    }
}

sub action {
    my ($self) = @_;
    if ($self->filetransform->to_fulfil && $self->filetransform->to_fulfil->status ne 'ready') {
        $self->filetransform->status('unfixable');
        $self->filetransform->update();
    }
    return;
}

__PACKAGE__->meta->make_immutable;
1;

