package state51::Job::SimpleFileCheck;
use state51::Moose;
use MooseX::Storage;
with Storage (format => "JSON");

use MooseX::Types::Moose qw/ Int /;

extends 'state51::Job';

sub exchange_name {
    return "simple_file_check";
}

sub suppress_console_display { 1 }

has classless_id => (
    isa => Int,
    is => 'ro',
    required => 1,
);

has full_checksum => (
    isa => Bool,
    is => 'ro',
    required => 1,
    default => 0,
);

method run() {
    state51::Base->connect;

    my $file = state51::File->load_polymorphic($self->classless_id);

    if ($self->full_checksum) {
        $file->local_file_path();
    }
    else {
        $file->mogile_paths();
    }
    $file->uncache();

    return;
}

with qw/
    
    state51::Mixin::Loggable
    state51::Mixin::JobLogger
    state51::Mixin::UnloadAfterJob
/;

__PACKAGE__->meta->make_immutable;
1;

