package state51::Job::UpdateExchangeRate;
use Moose;
use Moose::Util::TypeConstraints;
use MooseX::ClassAttribute;
use state51::Logger;

extends 'state51::Job';

class_has documentation => (
    is  => 'ro',
    isa => 'Str',
    default =>
'Get the most recent rates from the ECB.',
);

sub exchange_name {
    'update_exchange_rate';
}

sub suppress_console_display { 1 }

sub run {
    my ($self) = @_;
    state51::Base->connect;

    state51::ExchangeRate->fetch_or_create_current_eur_gbp_rate();

    return 1;
}

with qw/
  state51::Mixin::JobLogger
  /;

__PACKAGE__->meta->make_immutable;
__PACKAGE__->new_with_options->run unless caller;
1;
