package state51::Mixin::Loggable;

use MooseX::Role::WithOverloading;
use Scalar::Util qw/ blessed /;
 
use utf8 ();
use JSON;

=pod

=head1 DESCRIPTION

This module in a less fucked version of Log::Message::Structured::Stringify::AsJSON.
It should be consumed by object which need to be logged via ->as_string().

=cut

use overload
    q{""}    => 'as_string',
    fallback => 1;
         
has class => (
    init_arg => undef,
    is => 'ro',
    isa => 'Str',
    default => sub { blessed $_[0] },
);

sub as_hash {
    my ($self) = @_;

    return { map { $_->name, $_->get_value($self) }
             grep { $_->name eq '_order_object' or $_->name !~ m!^_! }
             $self->meta->get_all_attributes };
}

sub stringify { $_[0]->as_string }

sub as_string {
    my $self = shift;
    my $hashref = $self->as_hash;
    my $json = JSON->new->allow_blessed(1); # don't blow up on objects without FREEZE/TO_JSON methods
 	my $json_text = $json->encode( $hashref );
    utf8::decode($json_text)
		if !utf8::is_utf8($json_text) and utf8::valid($json_text); # if it's valid utf8 mark it as such
    return $json_text;
};

1;
